#include "dude.h"
#include "map.h"
#include <cstring>

Dude::Dude(const Coord &_pos, Map *_map, int &_team) :
    m_pos(_pos),
    p_map(_map),
    m_team(_team),
    m_dead(false),
    m_success(true),
    m_inventory(EMPTY)
{
    std::memset(&m_memory, 0, DUDE_MEMORY_SIZE);
    m_under = p_map->getPixel(m_pos).type;
    if(PixelProperty::isResource(m_under))
        m_underResCount = p_map->getPixel(m_pos).data.nbRes;
    p_map->getPixel(m_pos).type = DUDE;
    p_map->getPixel(m_pos).data.dudePtr = this;
}

char* Dude::getMemory()
{
    return m_memory;
}

void Dude::move(Dir d)
{
    p_map->getPixel(m_pos).type = m_under;
    if(PixelProperty::isResource(m_under))
        p_map->getPixel(m_pos).data.nbRes = m_underResCount;
    p_map->getPixel(m_pos).data.dudePtr = NULL;
    
    m_pos += Coord(d);
    
    m_under = p_map->getPixel(m_pos).type;
    if(PixelProperty::isResource(m_under))
        m_underResCount = p_map->getPixel(m_pos).data.nbRes;
    p_map->getPixel(m_pos).type = DUDE;
    p_map->getPixel(m_pos).data.dudePtr = this;
    p_map->toreillerLoop(m_pos);
}

void Dude::receiveComData(const Com &comData)
{
    std::memcpy(&m_comData, &comData, sizeof(Com));
}

PixelType Dude::getNear(Dir d) const
{
    return p_map->getPixel(Coord(d) + m_pos).type;
}

int Dude::getInfo(Dir d) const
{
    return p_map->getPixel(Coord(d) + m_pos).data.nbRes;
}
